var _ = require("lodash");
var fs = require("fs");
var isDirectory = require("is-directory");
var isThere = require("is-there");
var mkdirp = require("mkdirp");
var path = require("path");
var rimraf = require("rimraf");

var ignoredFiles = [
  ".git",
  "README.md"
];

var isLinkable = function(sourceDir, sourceFile){
  if (_.includes(ignoredFiles, sourceFile)){
    return false;
  }
  if(isDirectory.sync(path.resolve(sourceDir, sourceFile))){
    return false;
  }
  return true;
};

var assetSync = {};

var createLink = function(targetDir, sourceDir, sourceFile){
  if (!isLinkable(sourceDir, sourceFile)){
    return false;
  }

  mkdirp.sync(targetDir);
  var sourcePath = path.resolve(sourceDir, sourceFile);
  var targetPath = path.resolve(targetDir, sourceFile);
  if (isThere(targetPath)){
    rimraf.sync(targetPath);
  }
  try{
    fs.symlinkSync(sourcePath, targetPath);
  } catch(error){
    if (error.code !== "EEXIST"){
      throw error;
    }
  }

};

assetSync.allFiles = function(sourceDir, targetDir){
  var files = fs.readdirSync(sourceDir);
  createLinkInTarge = _.partial(createLink, targetDir, sourceDir);
  files.forEach(createLinkInTarge);
};

module.exports = assetSync;
